# Class AbstractSequentialList<E>

java.lang.Object
java.util.AbstractCollection<E>
java.util.AbstractList<E>
java.util.AbstractSequentialList<E>

Type Parameters:
  `E` - the type of elements in this list

All Implemented Interfaces:
  `Iterable<E>, Collection<E>, List<E>, SequencedCollection<E>`

Direct Known Subclasses:
  `LinkedList`

public abstract class AbstractSequentialList<E> extends AbstractList<E>
This class provides a skeletal implementation of the `List` interface to minimize the effort required to implement this interface backed by a "sequential access" data store (such as a linked list). For random access data (such as an array), `AbstractList` should be used in preference to this class.

This class is the opposite of the `AbstractList` class in the sense that it implements the "random access" methods (`get(int index)`, `set(int index, E element)`, `add(int index, E element)` and `remove(int index)`) on top of the list's list iterator, instead of the other way around.

To implement a list the programmer needs only to extend this class and provide implementations for the `listIterator` and `size` methods. For an unmodifiable list, the programmer need only implement the list iterator's `hasNext`, `next`, `hasPrevious`, `previous` and `index` methods.

For a modifiable list the programmer should additionally implement the list iterator's `set` method. For a variable-size list the programmer should additionally implement the list iterator's `remove` and `add` methods.

The programmer should generally provide a void (no argument) and collection constructor, as per the recommendation in the `Collection` interface specification.

This class is a member of the Java Collections Framework.

Since:
  1.2
See Also:
  - `Collection`
  - `List`
  - `AbstractList`
  - `AbstractCollection`

## Field Summary

### Fields declared in class AbstractList

`modCount`
Modifier and Type
Field
Description
`protected int`
`modCount`
The number of times this list has been structurally modified.

## Constructor Summary

Constructors
Modifier
Constructor
Description
`protected`
`AbstractSequentialList()`
Sole constructor.

## Method Summary

Modifier and Type
Method
Description
`void`
`add(int index, E element)`
Inserts the specified element at the specified position in this list (optional operation).
`boolean`
`addAll(int index, Collection<? extends E> c)`
Inserts all of the elements in the specified collection into this list at the specified position (optional operation).
`E`
`get(int index)`
Returns the element at the specified position in this list.
`Iterator<E>`
`iterator()`
Returns an iterator over the elements in this list (in proper sequence).
`abstract ListIterator<E>`
`listIterator(int index)`
Returns a list iterator over the elements in this list (in proper sequence).
`E`
`remove(int index)`
Removes the element at the specified position in this list (optional operation).
`E`
`set(int index, E element)`
Replaces the element at the specified position in this list with the specified element (optional operation).

### Methods declared in class AbstractList

`add, clear, equals, hashCode, indexOf, lastIndexOf, listIterator, removeRange, subList`
Modifier and Type
Method
Description
`boolean`
`add(E e)`
Appends the specified element to the end of this list (optional operation).
`void`
`clear()`
Removes all of the elements from this list (optional operation).
`boolean`
`equals(Object o)`
Compares the specified object with this list for equality.
`int`
`hashCode()`
Returns the hash code value for this list.
`int`
`indexOf(Object o)`
Returns the index of the first occurrence of the specified element in this list, or -1 if this list does not contain the element.
`int`
`lastIndexOf(Object o)`
Returns the index of the last occurrence of the specified element in this list, or -1 if this list does not contain the element.
`ListIterator<E>`
`listIterator()`
Returns a list iterator over the elements in this list (in proper sequence).
`protected void`
`removeRange(int fromIndex, int toIndex)`
Removes from this list all of the elements whose index is between `fromIndex`, inclusive, and `toIndex`, exclusive.
`List<E>`
`subList(int fromIndex, int toIndex)`
Returns a view of the portion of this list between the specified `fromIndex`, inclusive, and `toIndex`, exclusive.

### Methods declared in class AbstractCollection

`addAll, contains, containsAll, isEmpty, remove, removeAll, retainAll, toArray, toArray, toString`
Modifier and Type
Method
Description
`boolean`
`addAll(Collection<? extends E> c)`
Adds all of the elements in the specified collection to this collection (optional operation).
`boolean`
`contains(Object o)`
Returns `true` if this collection contains the specified element.
`boolean`
`containsAll(Collection<?> c)`
Returns `true` if this collection contains all of the elements in the specified collection.
`boolean`
`isEmpty()`
Returns `true` if this collection contains no elements.
`boolean`
`remove(Object o)`
Removes a single instance of the specified element from this collection, if it is present (optional operation).
`boolean`
`removeAll(Collection<?> c)`
Removes all of this collection's elements that are also contained in the specified collection (optional operation).
`boolean`
`retainAll(Collection<?> c)`
Retains only the elements in this collection that are contained in the specified collection (optional operation).
`Object[]`
`toArray()`
Returns an array containing all of the elements in this collection.
`<T> T[]`
`toArray(T[] a)`
Returns an array containing all of the elements in this collection; the runtime type of the returned array is that of the specified array.
`String`
`toString()`
Returns a string representation of this collection.

### Methods declared in class Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`
Modifier and Type
Method
Description
`protected Object`
`clone()`
Creates and returns a copy of this object.
`protected void`
`finalize()`
Deprecated, for removal: This API element is subject to removal in a future version.
Finalization is deprecated and subject to removal in a future release.
`final Class<?>`
`getClass()`
Returns the runtime class of this `Object`.
`final void`
`notify()`
Wakes up a single thread that is waiting on this object's monitor.
`final void`
`notifyAll()`
Wakes up all threads that are waiting on this object's monitor.
`final void`
`wait()`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
`final void`
`wait(long timeoutMillis)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
`final void`
`wait(long timeoutMillis, int nanos)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

### Methods declared in interface Collection

`parallelStream, removeIf, stream, toArray`
Modifier and Type
Method
Description
`default Stream<E>`
`parallelStream()`
Returns a possibly parallel `Stream` with this collection as its source.
`default boolean`
`removeIf(Predicate<? super E> filter)`
Removes all of the elements of this collection that satisfy the given predicate (optional operation).
`default Stream<E>`
`stream()`
Returns a sequential `Stream` with this collection as its source.
`default <T> T[]`
`toArray(IntFunction<T[]> generator)`
Returns an array containing all of the elements in this collection, using the provided `generator` function to allocate the returned array.

### Methods declared in interface Iterable

`forEach`
Modifier and Type
Method
Description
`default void`
`forEach(Consumer<? super E> action)`
Performs the given action for each element of the `Iterable` until all elements have been processed or the action throws an exception.

### Methods declared in interface List

`addAll, addFirst, addLast, contains, containsAll, getFirst, getLast, isEmpty, remove, removeAll, removeFirst, removeLast, replaceAll, retainAll, reversed, size, sort, spliterator, toArray, toArray`
Modifier and Type
Method
Description
`boolean`
`addAll(Collection<? extends E> c)`
Appends all of the elements in the specified collection to the end of this list, in the order that they are returned by the specified collection's iterator (optional operation).
`default void`
`addFirst(E e)`
Adds an element as the first element of this collection (optional operation).
`default void`
`addLast(E e)`
Adds an element as the last element of this collection (optional operation).
`boolean`
`contains(Object o)`
Returns `true` if this list contains the specified element.
`boolean`
`containsAll(Collection<?> c)`
Returns `true` if this list contains all of the elements of the specified collection.
`default E`
`getFirst()`
Gets the first element of this collection.
`default E`
`getLast()`
Gets the last element of this collection.
`boolean`
`isEmpty()`
Returns `true` if this list contains no elements.
`boolean`
`remove(Object o)`
Removes the first occurrence of the specified element from this list, if it is present (optional operation).
`boolean`
`removeAll(Collection<?> c)`
Removes from this list all of its elements that are contained in the specified collection (optional operation).
`default E`
`removeFirst()`
Removes and returns the first element of this collection (optional operation).
`default E`
`removeLast()`
Removes and returns the last element of this collection (optional operation).
`default void`
`replaceAll(UnaryOperator<E> operator)`
Replaces each element of this list with the result of applying the operator to that element (optional operation).
`boolean`
`retainAll(Collection<?> c)`
Retains only the elements in this list that are contained in the specified collection (optional operation).
`default List<E>`
`reversed()`
Returns a reverse-ordered view of this collection.
`int`
`size()`
Returns the number of elements in this list.
`default void`
`sort(Comparator<? super E> c)`
Sorts this list according to the order induced by the specified `Comparator` (optional operation).
`default Spliterator<E>`
`spliterator()`
Creates a `Spliterator` over the elements in this list.
`Object[]`
`toArray()`
Returns an array containing all of the elements in this list in proper sequence (from first to last element).
`<T> T[]`
`toArray(T[] a)`
Returns an array containing all of the elements in this list in proper sequence (from first to last element); the runtime type of the returned array is that of the specified array.

## Constructor Details

### AbstractSequentialList

protected AbstractSequentialList()
Sole constructor. (For invocation by subclass constructors, typically implicit.)

## Method Details

### get

public E get(int index)
Returns the element at the specified position in this list.

This implementation first gets a list iterator pointing to the indexed element (with `listIterator(index)`). Then, it gets the element using `ListIterator.next` and returns it.

Specified by:
  `get` in interface `List<E>`
Specified by:
  `get` in class `AbstractList<E>`
Parameters:
  `index` - index of the element to return
Returns:
  the element at the specified position in this list
Throws:
  `IndexOutOfBoundsException` - if the index is out of range (`index < 0 || index >= size()`)

### set

public E set(int index, E element)
Replaces the element at the specified position in this list with the specified element (optional operation).

This implementation first gets a list iterator pointing to the indexed element (with `listIterator(index)`). Then, it gets the current element using `ListIterator.next` and replaces it with `ListIterator.set`.

Note that this implementation will throw an `UnsupportedOperationException` if the list iterator does not implement the `set` operation.

Specified by:
  `set` in interface `List<E>`
Overrides:
  `set` in class `AbstractList<E>`
Parameters:
  `index` - index of the element to replace
  `element` - element to be stored at the specified position
Returns:
  the element previously at the specified position
Throws:
  `UnsupportedOperationException` - if the `set` operation is not supported by this list
  `ClassCastException` - if the class of the specified element prevents it from being added to this list
  `NullPointerException` - if the specified element is null and this list does not permit null elements
  `IllegalArgumentException` - if some property of the specified element prevents it from being added to this list
  `IndexOutOfBoundsException` - if the index is out of range (`index < 0 || index >= size()`)

### add

public void add(int index, E element)
Inserts the specified element at the specified position in this list (optional operation). Shifts the element currently at that position (if any) and any subsequent elements to the right (adds one to their indices).

This implementation first gets a list iterator pointing to the indexed element (with `listIterator(index)`). Then, it inserts the specified element with `ListIterator.add`.

Note that this implementation will throw an `UnsupportedOperationException` if the list iterator does not implement the `add` operation.

Specified by:
  `add` in interface `List<E>`
Overrides:
  `add` in class `AbstractList<E>`
Parameters:
  `index` - index at which the specified element is to be inserted
  `element` - element to be inserted
Throws:
  `UnsupportedOperationException` - if the `add` operation is not supported by this list
  `ClassCastException` - if the class of the specified element prevents it from being added to this list
  `NullPointerException` - if the specified element is null and this list does not permit null elements
  `IllegalArgumentException` - if some property of the specified element prevents it from being added to this list
  `IndexOutOfBoundsException` - if the index is out of range (`index < 0 || index > size()`)

### remove

public E remove(int index)
Removes the element at the specified position in this list (optional operation). Shifts any subsequent elements to the left (subtracts one from their indices). Returns the element that was removed from the list.

This implementation first gets a list iterator pointing to the indexed element (with `listIterator(index)`). Then, it removes the element with `ListIterator.remove`.

Note that this implementation will throw an `UnsupportedOperationException` if the list iterator does not implement the `remove` operation.

Specified by:
  `remove` in interface `List<E>`
Overrides:
  `remove` in class `AbstractList<E>`
Parameters:
  `index` - the index of the element to be removed
Returns:
  the element previously at the specified position
Throws:
  `UnsupportedOperationException` - if the `remove` operation is not supported by this list
  `IndexOutOfBoundsException` - if the index is out of range (`index < 0 || index >= size()`)

### addAll

public boolean addAll(int index, Collection<? extends E> c)
Inserts all of the elements in the specified collection into this list at the specified position (optional operation). Shifts the element currently at that position (if any) and any subsequent elements to the right (increases their indices). The new elements will appear in this list in the order that they are returned by the specified collection's iterator. The behavior of this operation is undefined if the specified collection is modified while the operation is in progress. (Note that this will occur if the specified collection is this list, and it's nonempty.)

This implementation gets an iterator over the specified collection and a list iterator over this list pointing to the indexed element (with `listIterator(index)`). Then, it iterates over the specified collection, inserting the elements obtained from the iterator into this list, one at a time, using `ListIterator.add` followed by `ListIterator.next` (to skip over the added element).

Note that this implementation will throw an `UnsupportedOperationException` if the list iterator returned by the `listIterator` method does not implement the `add` operation.

Specified by:
  `addAll` in interface `List<E>`
Overrides:
  `addAll` in class `AbstractList<E>`
Parameters:
  `index` - index at which to insert the first element from the specified collection
  `c` - collection containing elements to be added to this list
Returns:
  `true` if this list changed as a result of the call
Throws:
  `UnsupportedOperationException` - if the `addAll` operation is not supported by this list
  `ClassCastException` - if the class of an element of the specified collection prevents it from being added to this list
  `NullPointerException` - if the specified collection contains one or more null elements and this list does not permit null elements, or if the specified collection is null
  `IllegalArgumentException` - if some property of an element of the specified collection prevents it from being added to this list
  `IndexOutOfBoundsException` - if the index is out of range (`index < 0 || index > size()`)

### iterator

public Iterator<E> iterator()
Returns an iterator over the elements in this list (in proper sequence).

This implementation merely returns a list iterator over the list.

Specified by:
  `iterator` in interface `Collection<E>`
Specified by:
  `iterator` in interface `Iterable<E>`
Specified by:
  `iterator` in interface `List<E>`
Overrides:
  `iterator` in class `AbstractList<E>`
Returns:
  an iterator over the elements in this list (in proper sequence)

### listIterator

public abstract ListIterator<E> listIterator(int index)
Returns a list iterator over the elements in this list (in proper sequence).

Specified by:
  `listIterator` in interface `List<E>`
Overrides:
  `listIterator` in class `AbstractList<E>`
Parameters:
  `index` - index of first element to be returned from the list iterator (by a call to the `next` method)
Returns:
  a list iterator over the elements in this list (in proper sequence)
Throws:
  `IndexOutOfBoundsException` - if the index is out of range (`index < 0 || index > size()`)